import java.io.*;
import java.util.HashMap;
import java.util.StringTokenizer;

public class MinimumDistance {
    private static class Kattio extends PrintWriter {
        public Kattio(InputStream i) {
            super(new BufferedOutputStream(System.out));
            r = new BufferedReader(new InputStreamReader(i));
        }
        public Kattio(InputStream i, OutputStream o) {
            super(new BufferedOutputStream(o));
            r = new BufferedReader(new InputStreamReader(i));
        }

        public boolean hasMoreTokens() {
            return peekToken() != null;
        }

        public int getInt() {
            return Integer.parseInt(nextToken());
        }

        public double getDouble() {
            return Double.parseDouble(nextToken());
        }

        public long getLong() {
            return Long.parseLong(nextToken());
        }

        public String getWord() {
            return nextToken();
        }


        private BufferedReader r;
        private String line;
        private StringTokenizer st;
        private String token;

        private String peekToken() {
            if (token == null)
                try {
                    while (st == null || !st.hasMoreTokens()) {
                        line = r.readLine();
                        if (line == null) return null;
                        st = new StringTokenizer(line);
                    }
                    token = st.nextToken();
                } catch (IOException e) { }
            return token;
        }

        private String nextToken() {
            String ans = peekToken();
            token = null;
            return ans;
        }
    }

    public static void main(String[] args) throws IOException {
        Kattio io = new Kattio(System.in);

        int N = io.getInt();

        HashMap<Integer, Integer> previous = new HashMap<>();

        int min = Integer.MAX_VALUE;

        for (int i = 0; i < N; i++) {
            int value = io.getInt();

            if (previous.containsKey(value)) {
                if ((i - previous.get(value)) < min) {
                    min = i - previous.get(value);
                }
            }

            if (min == 1) {
                System.out.println(min);
                System.exit(0);
            }

            previous.put(value, i);
        }

        if (min < Integer.MAX_VALUE) {
            System.out.println(min);
        } else {
            System.out.println(N);
        }
    }
}
