#!/usr/bin/env python3
import sys, argparse, random


parser = argparse.ArgumentParser(description="Generator for nototents.")
parser.add_argument('-o', metavar='O', type=str, default="hamiltonian",
                    help='Options for generation (random, balanced, onepath, twopaths)')
parser.add_argument('-n', metavar='N', type=int, required=True,
                    help='size of graph - integer >=2 (required)')
parser.add_argument('-m', metavar='M', type=int, required=True,
                    help='number of edges')
parser.add_argument('-s', metavar='S', type=int, default=None,
                    help='seed for generation (optional)')
args = parser.parse_args()
random.seed(args.s)

option = args.o
n = args.n
m = args.m

graph = [[] for _ in range(n)]

if option == "hamiltonian":
    if m < n-1:
        raise Exception("m < n")
    
    for i in range(n-1):
        graph[i].append((i+1, random.randrange(0, 13)))
        
    for j in range(m-n+1):
        start = random.randrange(0, n)
        end = random.randrange(0, n)
        graph[start].append((end, random.randrange(0, 13)))
    



# shuffle indices (except 0 and n-1)
mid = list(range(1, n-1))
random.shuffle(mid)
mp = [0] + list(mid) + [n-1]

# print output
print(n, m)
for i in range(n):
    for (j, w) in graph[i]:
        ea, eb = (mp[i], mp[j]) if random.random() < 0.5 else (mp[j] , mp[i])
        print(ea, eb, w)
        