#include <cstdio>
#include <queue>

struct edge{
	int v,w;
	edge(int v, int w) : v(v), w(w) {}
	friend bool operator<(const edge &l, const edge &r){
		return l.w > r.w;
	}
};

int main(){
	int n, m, olsenwalk, larsenwalk;
	scanf("%d %d", &n, &m);
	std::vector<std::vector<edge> > G(n, std::vector<edge>());
	int u,k,w;
	while(m--){
		scanf("%d %d %d", &u, &k, &w);
		G[u].emplace_back(k,w);
		G[k].emplace_back(u,w);
	}

	std::priority_queue<edge> pq;
	std::vector<bool> v(n, false);
	pq.emplace(0,0);
	while(!pq.empty()){
		u = pq.top().v; 
		w = pq.top().w;
		pq.pop();
		if(u == n-1){
			olsenwalk = w;
			break;
		}
		if(v[u])
			continue;
		v[u] = true;
		for(const edge &e : G[u]){
			if(!v[e.v])
				pq.emplace(e.v, w + e.w);
		}
	}

	int olsentravel = std::max(0,(olsenwalk-1)/12) * 12 + olsenwalk;


	pq = std::priority_queue<edge>();
	v.assign(n,false);
	pq.emplace(0,0);
	while(!pq.empty()){
		u = pq.top().v;
		w = pq.top().w;
		pq.pop();
		if(u == n-1){
			larsenwalk = w;
			break;
		}
		if (v[u])
			continue;
		v[u] = true;
		for(const edge &e : G[u]){
			if(e.w <= 12){
				int alt = -1;
				if ((w % 12) + e.w <= 12)
					alt = w + e.w;
				else
					alt = w + 12 - (w % 12) + e.w;
				pq.emplace(e.v, alt);
			}
		}
	}


	int larsentravel = std::max(0,(larsenwalk - 1) / 12) * 12 + larsenwalk;

	printf("%d\n", larsentravel-olsentravel);
	return 0;
}
