#!/bin/bash

# Set the problem name to generate correct file names
PROBLEMNAME="ispmerger"

SOLVER="python submissions/accepted/simple.py"

subfolders=(data/secret)
for i in ${subfolders[@]}
do
    rm -r $i
    if [ ! -d $i ]
    then
        mkdir $i
    fi
done


echo "Generating..."
DR="data/secret"

./generate.py -n 4 -m 3 -s 1 > $DR/01.in
./generate.py -n 8 -m 20 -s 2 > $DR/02.in
./generate.py -n 3 -m 3 -s 3 > $DR/03.in
./generate.py -n 9 -m 20 -s 4 > $DR/04.in
./generate.py -n 7 -m 20 -s 5 > $DR/05.in
./generate.py -n 2 -m 20 -s 6 > $DR/06.in
./generate.py -n 10 -m 20 -s 7 > $DR/07.in
./generate.py -n 5 -m 20 -s 8 > $DR/08.in
./generate.py -n 11 -m 20 -s 9 > $DR/09.in
./generate.py -n 6 -m 20 -s 10 > $DR/10.in
./generate.py -n 12 -m 20 -s 11 > $DR/11.in
./generate.py -n 1 -m 20 -s 12 > $DR/12.in
./generate.py -n 13 -m 15 -s 13 > $DR/13.in
./generate.py -n 9 -m 14 -s 14 > $DR/14.in
./generate.py -n 18 -m 8 -s 15 > $DR/15.in
./generate.py -n 15 -m 20 -s 16 > $DR/16.in
./generate.py -n 20 -m 20 -s 17 > $DR/17.in
./generate.py -n 1 -m 20 -s 18 > $DR/18.in
./generate.py -n 17 -m 20 -s 19 > $DR/19.in
./generate.py -n 16 -m 20 -s 20 > $DR/20.in

# generate solutions for all files
if [[ ! -z $SOLVER ]]
then
    for i in ${subfolders[@]}
    do
        for f in $i/*.in
        do
            echo "solving $f"
            $SOLVER < $f > ${f%???}.ans
        done
    done
fi
