from __future__ import print_function, division

def mmult(a, b):
    res = [0]*(64*64)
    for i in xrange(64):
        for j in xrange(64):
            for k in xrange(64):
                res[64*i + j] += a[64*i + k] * b[64*k + j]

    return res

def mexp(n, m):
    if n == 1:
        return m
    
    m2 = mexp(n // 2, m)

    return mmult(m2,m2) if n % 2 == 0 else mmult(m, mmult(m2, m2))


def main():
    r,c,n = (int(x) for x in raw_input().split())
    p = float(raw_input())
    
    ladders = [-1 for _ in xrange(r*c)]
    for i in xrange(n):
        a,b = (int(x)-1 for x in raw_input().split())
        ladders[a] = b

    mat = [0]*(64*64)

    for i in xrange(r*c):
        for j in xrange(1,7):
            if i + j >= r*c - 1:
                mat[64*i + r*c-1] += 1.0 / 6.0
            elif ladders[i+j] != -1:
                mat[64*i + ladders[i+j]] += 1.0 / 6.0
            else:
                mat[64*i + i+j] += 1.0 / 6.0
    
    a = 1
    b = 100000000
    while (a < b):
        m = (a+b) // 2
        if mexp(m, mat)[r*c-1] >= p:
            b = m
        else:
            a = m+1

    print(a)

main()
