import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

/**
 * Created by olav on 17.10.18.
 */
public class ExpectingRain {

    public static void main (String args[]) throws Exception{
        Input in = new Input();
        int d = in.nextInt();
        int t = in.nextInt();
        int f = in.nextInt();
        int r = in.nextInt();

        boolean hasroof[] = new boolean[d+1];
        double expectedRain[] = new double[t+1];

        for (int i = 0; i < f; i++){
            int start = in.nextInt();
            int stop = Math.min(t, in.nextInt());
            double expected = in.nextDouble()*in.nextDouble();
            expectedRain[start] += expected;
            expectedRain[stop] -= expected;
        }

        for (int i = 1; i < t; i++){
            expectedRain[i] = expectedRain[i-1] + expectedRain[i];
        }

        for (int i = 0; i < r; i++){
            int start = in.nextInt();
            int stop = in.nextInt();
            for (int j = start; j < stop; j++){
                hasroof[j] = true;
            }
        }

        double DP[][] = new double[d+1][t+1]; //dist : time

        DP[0][0] = 0;
        for (int i = 1; i <= d; i++){
            DP[i][0] = Long.MAX_VALUE;
        }
        for (int i = 1; i <= t; i++){
            DP[0][i] = 0;
        }

        for (int i = 1; i <= d; i++){
            for (int j = 1; j <= t; j++){
                double walk, wait;
                if (hasroof[i-1]) walk = DP[i-1][j-1];
                else walk = DP[i-1][j-1] + expectedRain[j-1];
                if (hasroof[i]) wait = DP[i][j-1];
                else wait = DP[i][j-1] + expectedRain[j-1];
                DP[i][j] = Math.min(walk, wait);
            }
        }

        System.out.println(DP[d][t]);
    }

    static class Tuple{
        int s;
        double value;

        Tuple(int s, double value){
            this.s = s;
            this.value = value;
        }
    }

    static class Input{
        StringTokenizer st;
        BufferedReader br;

        Input(){
            st = new StringTokenizer("");
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        int nextInt() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Integer.parseInt(st.nextToken());
        }

        long nextLong() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Long.parseLong(st.nextToken());
        }

        double nextDouble() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Double.parseDouble(st.nextToken());
        }

        String nextToken() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return st.nextToken();
        }
    }
}
