#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

constexpr int MAXD = 1005;
constexpr int MAXT = 10005;

int d, t, c, r;
double rain[MAXT], M[MAXT][MAXD];
bool roof[MAXD];

int main() {
    ios::sync_with_stdio(false);
    cin >> d >> t >> c >> r;

    for (int i = 0; i < c; i++) {
        int s, e, a;
        double p;
        cin >> s >> e >> p >> a;
        rain[s] += p*a;
        rain[e] += -p*a;
    }

    for (int i = 1; i <= t; i++)
        rain[i] += rain[i-1];

    for (int i = 0; i < r; i++) {
        int x, y;
        cin >> x >> y;
        while (y-- > x)
            roof[y] = true;
    }

    for (int i = 0; i <= t; i++)
        M[i][0] = 0;
    for (int i = 1; i <= d; i++)
        M[0][i] = 1e100;

    for (int i = 1; i <= t; i++) for (int j = 1; j <= d; j++) {
        double walk = roof[j-1] ? M[i-1][j-1] : M[i-1][j-1] + rain[i-1];
        double wait = roof[j] ? M[i-1][j] : M[i-1][j] + rain[i-1];
        M[i][j] = min(walk, wait);
    }

    cout << fixed << setprecision(7) << M[t][d] << endl;
}
